;/*******************************/;
;/* Demo Timer MCS51 For ET-EXP4*/;
;/* Files Name  : LAB10EX1.ASM  */;
;/* CPU Control : MCS-51 Family */;
;/* Assembler   : SXA51.EXE     */;
;/* -Timer Run  : Interupt Mode */;
;/*(Generate Squarewave on P1.0)*/;
;/*******************************/;
;
;/* Port For Generate PWM
PORT_SQU    EQU     P1.0                    ; Port.0 = Square Wave Output

            ORG     20H                     ; Internal RAM of CPU
FLAG_BUF:   DS      1                       ; Flag Status
HALF_DLY:   DS      2                       ; Square Wave Period
            ;
PWM_STAS    EQU     FLAG_BUF.0              ; Set = 1,Clr = 0

            ORG     0000H                   ; Reset Vector of CPU
            LJMP    MAIN
            ORG     000BH                   ; Timer0 Vector Interupt
            LJMP    TIMER_INT

MAIN:       MOV     SP,#128-32              ; Stack = 32 Byte Internal RAM
            CLR     PWM_STAS
            MOV     TMOD,#00000001B         ; Timer0 Mode1 (16Bit)
            MOV     HALF_DLY+0,#024H        ; 10 milliSec Period(50Hz)
            MOV     HALF_DLY+1,#000H
            SETB    ET0                     ; Enable Timer0 Interupt
            SETB    TR0                     ; Start Timer0
            SETB    EA                      ; Enable Global Interupt
            ;
            SJMP    $                       ; Loop Here For Interupt

;/*****************************/;
;/* Timer 0 Interrupt Service */;
;/*  Auto Reload on Interupt  */;
;/*****************************/;
;
TIMER_INT:  MOV     A,HALF_DLY+0            ; 1'Complement
            CPL     A                       
            MOV     DPH,A
            MOV     A,HALF_DLY+1
            CPL     A
            MOV     DPL,A
            INC     DPTR                    ; 2'Complement
            MOV     TH0,DPH                 ; Reload Next Time
            MOV     TL0,DPL
            CPL     PORT_SQU                ; Toggle Logic Output
            RETI

            END


