;/********************************/;
;/* Demo Display 5x7 For ET-EXP4 */;
;/* Files Name  : LAB3-EX2.ASM   */;
;/* CPU Control : MCS51 Family   */;
;/* Assembler   : SXA51.EXE      */;
;/*  (Move  Right <-----> Left)  */;
;/********************************/;
;
PORT_DSP    EQU     P1                  ; Port Display Control
;
;/** 74HC595 = Colum Control
COL_RESET   EQU     PORT_DSP.0          ; Reset  Clock  74HC595
COL_SHIFT   EQU     PORT_DSP.1          ; Shift  Clock  74HC595
COL_LATCH   EQU     PORT_DSP.2          ; Latch  Clock  74HC595
COL_ENABLE  EQU     PORT_DSP.3          ; Enable Output 74HC595
COL_DATA    EQU     PORT_DSP.5          ; Data   Input  74HC595
;
;/** 4017 = Row Control
ROW_ENABLE  EQU     PORT_DSP.4          ; Enable 4017
ROW_RESET   EQU     PORT_DSP.6          ; Reset 4017
ROW_DATA    EQU     PORT_DSP.7          ; Clock Input 4017

            ORG     20H
DSP_BUFF:   DS      21                  ; Display Buffer (7-Byte : 1 Font)
DATA_INX:   DS      1                   ; Index Get Buffer Display (SCAN_DSP)
BIT_MOVE:   DS      1                   ; Counter Bit Move on 1-Font
INX_MOVE:   DS      1                   ; Index Get Font (Move Left <--> Right)
FONT_CNT:   DS      1                   ; Char Move Count on Style
;AUX_BUFF:   DS      2                   ; Aux. Buffer
STACK:      DS      32                  ; Stack 32 Byte

            ORG     0000H               ; Reset Vector
MAIN:       MOV     SP,#STACK           ; Stack = 32 Byte Internal RAM
            ;
            MOV     R2,#21
            MOV     R0,#DSP_BUFF        ; Clear Scan Buffer
            CLR     A
CLR_BUFF:   MOV     @R0,A
            INC     R0
            DJNZ    R2,CLR_BUFF
            ;
            ;/* Move Display Right to Left Style
SHF_LEFT:   MOV     FONT_CNT,#13        ; 13 Char Move Left (0-9,Sp,Sp,Sp)
            MOV     INX_MOVE,#0         ; Index Get Font in Table
            ;
            ;/* Get Font From Table to Buffer
SHF_LFT0:   MOV     DPTR,#TAB_FONT      ; Table Font
            MOV     A,INX_MOVE          ; 1st Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+14     ; Display Buffer Font-4
SHF_LFT1:   CLR     A
            MOVC    A,@A+DPTR
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,SHF_LFT1
            ;
            MOV     BIT_MOVE,#6         ; 6-Bit Shift : 1-Font
            ;
            ;/* Shift Right to Left 6 Bit : 1-Font
SHF_LFT2:   MOV     R2,#7               ; 7 Row Shift Count
            MOV     R0,#DSP_BUFF+7      ; Point to Buffer Font-2
            MOV     R1,#DSP_BUFF+14     ; Point to Buffer Font-3
SHF_LFT3:   MOV     A,@R1               ; Get Buffer Font-3
            CLR     CY
            RLC     A                   ; CY <-- D7 <-- D0 <-- 0
            MOV     @R1,A               ; Update Buffer Font-3
            MOV     A,@R0               ; Get Buffer Font-2
            RLC     A                   ; CY <-- D7 <-- D0 <-- CY
            MOV     @R0,A               ; Update Buffer Font-2
            ;
            PUSH    00                  ; Save R0
            DEC     R0
            DEC     R0
            DEC     R0
            DEC     R0
            DEC     R0
            DEC     R0
            DEC     R0
            MOV     A,@R0               ; Get Buffer Font-1
            RLC     A                   ; CY <-- D7 <-- D0 <-- CY
            MOV     @R0,A               ; Update Buffer Font-1
            POP     00                  ; Restore R0
            ;
            INC     R0                  ; Next Row Shift
            INC     R1
            DJNZ    R2,SHF_LFT3
            ;
            MOV     B,#50               ; Display 50 Round Before Next Shift
SHF_LFT4:   LCALL   SCAN_DSP
            DJNZ    B,SHF_LFT4
            ;
            DJNZ    BIT_MOVE,SHF_LFT2   ; Repeat Move 6 Bit
            INC     INX_MOVE            ; Shift New Font
            DJNZ    FONT_CNT,SHF_LFT0   ; Repeat Move 13 Font
            ;
            ;/* Move Display Left to Right Style
SHF_RIGHT:  MOV     FONT_CNT,#13        ; 13 Char Move Left (0-9,Sp,Sp,Sp)
            MOV     INX_MOVE,#0         ; Index Get Font in Table
            ;
            ;/* Get Font From Table to Buffer
SHF_RGT0:   MOV     DPTR,#TAB_FONT      ; Table Font
            MOV     A,INX_MOVE          ; 1st Code
            MOV     B,#7                ; 7-Byte : 1-Font
            MUL     AB                  ; AxB = Pointer Font
            CLR     C
            ADDC    A,DPL               ; Low Byte first
            MOV     DPL,A
            MOV     A,B
            ADDC    A,DPH               ; High Byte + Carry
            MOV     DPH,A
            ;
            MOV     R2,#7
            MOV     R0,#DSP_BUFF+14     ; Display Buffer Font-4
SHF_RGT1:   CLR     A
            MOVC    A,@A+DPTR
            RR      A                   ; Shift Font to Right
            RR      A
            RR      A
            MOV     @R0,A
            INC     R0
            INC     DPTR
            DJNZ    R2,SHF_RGT1
            ;
            MOV     BIT_MOVE,#6         ; 6-Bit Shift : 1-Font
            ;
            ;/* Shift Left to Right 6 Bit : 1-Font
SHF_RGT2:   MOV     R2,#7               ; 7 Row Shift Count
            MOV     R0,#DSP_BUFF+0      ; Point to Buffer Font-1
            MOV     R1,#DSP_BUFF+14     ; Point to Buffer Font-3
SHF_RGT3:   MOV     A,@R1               ; Get Buffer Font-3
            CLR     CY
            RRC     A                   ; CY <-- D7 <-- D0 <-- 0
            MOV     @R1,A               ; Update Buffer Font-3
            MOV     A,@R0               ; Get Buffer Font-1
            RRC     A                   ; CY <-- D7 <-- D0 <-- CY
            MOV     @R0,A               ; Update Buffer Font-1
            ;
            PUSH    00                  ; Save R0
            INC     R0
            INC     R0
            INC     R0
            INC     R0
            INC     R0
            INC     R0
            INC     R0                  ; DSP_BUFF+7
            MOV     A,@R0               ; Get Buffer Font-1
            RRC     A                   ; CY <-- D7 <-- D0 <-- CY
            MOV     @R0,A               ; Update Buffer Font-1
            POP     00                  ; Restore R0
            ;
            INC     R0                  ; Next Row Shift
            INC     R1
            DJNZ    R2,SHF_RGT3
            ;
            MOV     B,#50               ; Display 50 Round Before Next Shift
SHF_RGT4:   LCALL   SCAN_DSP
            DJNZ    B,SHF_RGT4
            ;
            DJNZ    BIT_MOVE,SHF_RGT2   ; Repeat Move 6 Bit
            INC     INX_MOVE            ; Shift New Font
            DJNZ    FONT_CNT,SHF_RGT0   ; Repeat Move 13 Font
            ;
            JMP     SHF_LEFT

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan Display 3 Dotmatrix */;
;/* Input : DSP_BUFF0..13(14Byte)*/;
;/********************************/;
;
SCAN_DSP:   PUSH    B                   ; Save B
            SETB    COL_RESET           ; Start 74HC595 Pin
            CLR     ROW_ENABLE          ; Enable Row Output (4017)
            SETB    ROW_RESET           ; Clear Row Output Scan
            CLR     ROW_RESET
            ;
            MOV     R0,#DSP_BUFF+0      ; Display Buffer Left
            MOV     R1,#DSP_BUFF+7      ; Display Buffer Right
            MOV     B,#7                ; 7-Row Counter Scan
SCAN_DSP1:  SETB    COL_ENABLE          ; Disable Output Colum (74HC595)
            MOV     A,@R1               ; Right Digit
            CPL     A
            LCALL   SER_OUT             ; Send Data to Col 0-7
            MOV     A,@R0               ; Left Digit
            CPL     A
            LCALL   SER_OUT             ; Send Data to Col 8-15
            ;
            SETB    COL_LATCH           ; Latch Data Colum
            CLR     COL_LATCH
            SETB    ROW_DATA            ; Row Scan = Row Scan+1
            CLR     ROW_DATA
            CLR     COL_ENABLE          ; Enable Colum (74HCT595)
            ;
            MOV     R5,#1               ; Delay Time Counter
SCAN_DSP2:  MOV     R6,#00H
            DJNZ    R6,$
            DJNZ    R5,SCAN_DSP2        ; Delay for Eye
            INC     R0                  ; Next Row Buffer
            INC     R1
            DJNZ    B,SCAN_DSP1         ; Loop Until 7 Row Complete
            ;
            SETB    ROW_DATA            ; Shift Clock Over 1-Row
            CLR     ROW_DATA
            SETB    ROW_ENABLE          ; Disable Output Row (4017)
            POP     B                   ; Restore B
            RET

;/*************************/;
;/* Shift Data to 74HC595 */;
;/* Input : ACC           */;
;/*************************/;
;
SER_OUT:    MOV     R2,#8               ; Counter data ShiftOut 1 Byte
            CLR     CY
SHF_OUT:    RRC     A                   ; Shift Out data D0..D7
            MOV     COL_DATA,C
            NOP
            NOP
            SETB    COL_SHIFT           ; Shift Clock at Rising Edge
            NOP
            NOP
            CLR     COL_SHIFT
            NOP
            NOP
            DJNZ    R2,SHF_OUT          ; Loop Send This Byte
            RET

;/*********************/;
;/* Table of Font 5x7 */;
;/*********************/;
;
TAB_FONT:   DB      00110000B           ; 0
            DB      01001000B
            DB      01001000B
            DB      01001000B
            DB      01001000B
            DB      01001000B
            DB      00110000B
            ;
            DB      00010000B           ; 1
            DB      00110000B
            DB      00010000B
            DB      00010000B
            DB      00010000B
            DB      00010000B
            DB      00111000B
            ;
            DB      00110000B           ; 2
            DB      01001000B
            DB      00001000B
            DB      00010000B
            DB      00100000B
            DB      01000000B
            DB      01111000B
            ;
            DB      01111000B           ; 3
            DB      00010000B
            DB      00100000B
            DB      00010000B
            DB      00001000B
            DB      01001000B
            DB      00110000B
            ;
            DB      01000000B           ; 4
            DB      01000000B
            DB      01010000B
            DB      01010000B
            DB      01111000B
            DB      00010000B
            DB      00010000B
            ;
            DB      01111000B           ; 5
            DB      01000000B
            DB      01110000B
            DB      00001000B
            DB      00001000B
            DB      01001000B
            DB      00110000B
            ;
            DB      00010000B           ; 6
            DB      00100000B
            DB      01000000B
            DB      01110000B
            DB      01001000B
            DB      01001000B
            DB      00110000B
            ;
            DB      01111000B           ; 7
            DB      00001000B
            DB      00001000B
            DB      00010000B
            DB      00100000B
            DB      00100000B
            DB      00100000B
            ;
            DB      00110000B           ; 8
            DB      01001000B
            DB      01001000B
            DB      00110000B
            DB      01001000B
            DB      01001000B
            DB      00110000B
            ;
            DB      00110000B           ; 9
            DB      01001000B
            DB      01001000B
            DB      00111000B
            DB      00001000B
            DB      00010000B
            DB      00100000B
            ;
            DB      00000000B           ; Sp
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            ;
            DB      00000000B           ; Sp
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            ;
            DB      00000000B           ; Sp
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B
            DB      00000000B

            END



