;/*******************************/;
;/* Demo 7-SEG Scan For ET-EXP4 */;
;/* Files Name  : LAB1-EX2.ASM  */;
;/* CPU Control : 68HC811E2     */;
;/* Assembler   : AS11NEW.EXE   */;
;/*   (Scan 7-Segment "0123")   */;
;/*******************************/;
;
;/* Port For Control 7-Segment
PORT_ROW    EQU     $1003               ; Data Drive 7 Segment (Port-C)
CTRL_ROW    EQU     $1007               ; DDRC (0=In,1=Out)
PORT_COL    EQU     $1004               ; Port-B = Colum Scan

            ORG     $00
DSP_BUFF    RMB     4                   ; Display buffer 4 Byte
COL_SCAN    RMB     1                   ; Colum Buffer Data Scan
DIG_SCAN    RMB     1                   ; 7-Segment Digit Count

            ORG     $F800               ; Start Monitor of 68HC811E2
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDAB    #$FF
            STAB    CTRL_ROW            ; Port-C = Output
            ;
            CLRB
            STAB    DSP_BUFF+0          ; Digit1 = 0
            INCB
            STAB    DSP_BUFF+1          ; Digit2 = 1
            INCB
            STAB    DSP_BUFF+2          ; Digit3 = 2
            INCB
            STAB    DSP_BUFF+3          ; Digit4 = 3
            ;
SCAN7SEG    LDX     #DSP_BUFF           ; Display Buffer Code
            CLR     COL_SCAN            ; Colum Multiplex Code
            LDAB    #4
            STAB    DIG_SCAN            ; 4 Digit Counter Scan
            ;
SCANSEG1    LDAB    0,X                 ; Get Left Digit 7-Segment
            LDY     #TAB_SEG
            ABY
            LDAB    0,Y                 ; Convert to 7-Segment Code
            STAB    PORT_ROW
            LDAB    COL_SCAN
            STAB    PORT_COL            ; Active Colum Scan
            ;
            LDAB    #100                ; Scan Delay Counter
SCANSEG2    DECB
            BNE     SCANSEG2
            ;
            INX                         ; Next Row Buffer
            INC     COL_SCAN
            DEC     DIG_SCAN
            BNE     SCANSEG1            ; Loop Until Row Complete (4-Seg)
            BRA     SCAN7SEG            ; Repeat Scan Continue

;/************************/;
;/* Table 7-Segment Code */;
;/*   Dp A B C D E F G   */;
;/*   D7............D0   */;
;/************************/;
;
TAB_SEG     FCB     $3F,$06,$5B,$4F     ; 0 1 2 3
            FCB     $66,$6D,$7D,$07     ; 4 5 6 7
            FCB     $7F,$6F,$77,$7C     ; 8 9 A B
            FCB     $39,$5E,$79,$71     ; C D E F

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN

            END


