;/********************************/;
;/* Demo Display 5x7 For ET-EXP4 */;
;/* Files Name  : LAB3-EX1.ASM   */;
;/* CPU Control : 68HC811E2      */;
;/* Assembler   : AS11NEW.EXE    */;
;/*  (Scan Display Message 5*7)  */;
;/********************************/;
;
PORT_DSP    EQU     $1003               ; Port-C
DDRC        EQU     $1007               ; Port-C Direction
;
;/** 74HC595 = Colum Control
COL_RESET   EQU     %00000001           ; Reset  Clock  74HC595 (PC0)
COL_SHIFT   EQU     %00000010           ; Shift  Clock  74HC595 (PC1)
COL_LATCH   EQU     %00000100           ; Latch  Clock  74HC595 (PC2)
COL_ENABLE  EQU     %00001000           ; Enable Output 74HC595 (PC3)
COL_DATA    EQU     %00100000           ; Data   Input  74HC595 (PC5)
;
;/** 4017 = Row Control
ROW_ENABLE  EQU     %00010000           ; Enable 4017           (PC4)
ROW_RESET   EQU     %01000000           ; Reset 4017            (PC6)
ROW_DATA    EQU     %10000000           ; Clock Input 4017      (PC7)

            ORG     $00
DSP_BUFF    RMB     14                  ; Display Buffer Font (14 Byte)
DATA_INX    RMB     1                   ; Index Read Buffer (SCAN_DSP)
INX_BUFF    RMB     3                   ; Display Code 3-Byte
AUX_BUFF    RMB     2                   ; Aux. Buffer

            ORG     $F800               ; Reset Vector
MAIN        LDS     #$FF                ; Stack = Last Internal RAM
            LDAB    #$FF
            STAB    DDRC                ; All Port-C = Output
            ;
            LDAB    #14
            LDX     #DSP_BUFF           ; Clear Scan Buffer
            CLRA
CLR_BUFF    STAA    0,X
            INX
            DECB
            BNE     CLR_BUFF
            ;
            CLRB
            STAB    INX_BUFF+0          ; Code 0 = 5
            INCB
            STAB    INX_BUFF+1          ; Code 1 = *
            INCB
            STAB    INX_BUFF+2          ; Code 2 = 7
            JSR     UNPK_DSP            ; Store Data to Memory Display
            ;
LOOP        JSR     SCAN_DSP            ; Get Memory Display to Display
            BRA     LOOP

;/**********************************/;
;/* Get Code in INX_BUFF & Convert */;
;/* to Font and Store to DSP_BUFF  */;
;/* Input  : INX_BUFF0..2 (3-Code) */;
;/* Output : DSP_BUFF (Font Code)  */;
;/**********************************/;
;
UNPK_DSP    LDX     #TAB_FONT           ; Use Font 5x7
            STX     AUX_BUFF
            LDAA    INX_BUFF+0          ; 1st Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Pointer Font
            LDAB    #7
            LDY     #DSP_BUFF+0         ; Display Buffer Font-1
UNPK_DAT1   LDAA    0,X
            STAA    0,Y
            INX
            INY
            DECB
            BNE     UNPK_DAT1
            ;
            LDX     #TAB_FONT           ; Use Font 5x7
            STX     AUX_BUFF
            LDAA    INX_BUFF+1          ; 2nd Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Pointer Font
            LDAB    #7
            LDY     #DSP_BUFF+0         ; Display Buffer Font-1
UNPK_DAT2   LDAA    0,X
            LSRA                        ; Shift Right 5 Bit
            LSRA
            LSRA
            LSRA
            LSRA
            ORAA    0,Y
            STAA    0,Y
            INX
            INY
            DECB
            BNE     UNPK_DAT2
            ;
            LDX     #TAB_FONT           ; Use Font 5x7
            STX     AUX_BUFF
            LDAA    INX_BUFF+1          ; 2nd Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Pointer Font
            LDAB    #7
            LDY     #DSP_BUFF+7         ; Display Buffer Font-2
UNPK_DAT3   LDAA    0,X
            LSLA                        ; Shift Left 3 Bit
            LSLA
            LSLA
            ANDA    #%11000000
            STAA    0,Y
            INX
            INY
            DECB
            BNE     UNPK_DAT3
            ;
            LDX     #TAB_FONT           ; Use Font 5x7
            STX     AUX_BUFF
            LDAA    INX_BUFF+2          ; 3rd Code
            LDAB    #7                  ; 7-Byte : 1-Font
            MUL                         ; AxB = D
            ADDD    AUX_BUFF
            PSHB
            PSHA
            PULX                        ; X = Font
            LDAB    #7
            LDY     #DSP_BUFF+7         ; Scan Buffer Font2
UNPK_DAT4   LDAA    0,X
            LSRA                        ; Shift Right 2 Bit
            LSRA
            ORAA    0,Y
            STAA    0,Y
            INX
            INY
            DECB
            BNE     UNPK_DAT4
            RTS

;/********************************/;
;/* Get Data From Display Buffer */;
;/* and Scan Display 3 Dotmatrix */;
;/* Input : DSP_BUFF0..13(14Byte)*/;
;/********************************/;
;
SCAN_DSP    PSHX                        ; Save Register
            PSHA
            PSHB
            ;
            LDX     #PORT_DSP
            BSET    0,X COL_RESET       ; Start 74HC595 Pin
            BCLR    0,X ROW_ENABLE      ; Enable Row Output (4017)
            BSET    0,X ROW_RESET       ; Clear Row Output Scan
            BCLR    0,X ROW_RESET
            ;
            CLR     DATA_INX
            LDAB    #7                  ; 7-Row Counter Scan
SCAN_DSP1   BSET    0,X COL_ENABLE      ; Disable Out Colum (74HC595)
            ;
            PSHB                        ; Save Row Counter
            LDY     #DSP_BUFF+7         ; Display Buffer Font-2
            LDAB    DATA_INX
            ABY
            LDAA    0,Y                 ; Right Digit
            COMA
            JSR     SER_OUT             ; Send Data to Col 0-7
            LDY     #DSP_BUFF+0         ; Display Buffer Font-1
            LDAB    DATA_INX
            ABY
            LDAA    0,Y                 ; Left Digit
            COMA
            JSR     SER_OUT             ; Send Data to Col 8-15
            ;
            BSET    0,X COL_LATCH       ; Latch Data Colum
            BCLR    0,X COL_LATCH
            BSET    0,X ROW_DATA        ; Row Scan = Row Scan+1
            BCLR    0,X ROW_DATA
            BCLR    0,X COL_ENABLE      ; Enable Colum (74HCT595)
            ;
            LDAB    #100
SCAN_DSP2   DECB
            BNE     SCAN_DSP2           ; Delay for EYE
            ;
            INC     DATA_INX            ; Next Row Buffer
            PULB                        ; Restore Row Counter
            DECB
            BNE     SCAN_DSP1           ; Loop Until 7 Row Complete
            ;
            BSET    0,X ROW_DATA        ; Shift Over 1-Row
            BCLR    0,X ROW_DATA
            BSET    0,X ROW_ENABLE      ; Disable Row (4017)
            ;
            PULB                        ; Restore Register
            PULA
            PULX
            RTS

;/*************************/;
;/* Shift Data to 74HC595 */;
;/* Input : ACCA          */;
;/*************************/;
;
SER_OUT     LDAB    #8                  ; Counter data ShiftOut 1 Byte
SHF_OUT     RORA                        ; Shift Out data D0..D7
            BCS     SET_DAT
            BCLR    0,X COL_DATA
            BRA     SHF_CLK
SET_DAT     BSET    0,X COL_DATA
SHF_CLK     BSET    0,X COL_SHIFT       ; Shift Data at Rising Edge
            BCLR    0,X COL_SHIFT
            DECB
            BNE     SHF_OUT             ; Loop Send This Byte
            RTS

;/*********************/;
;/* Table of Font 5x7 */;
;/*********************/;
;
TAB_FONT    FCB     %11111000           ; 5
            FCB     %10000000
            FCB     %11110000
            FCB     %00001000
            FCB     %00001000
            FCB     %10001000
            FCB     %01110000
            ;
            FCB     %00000000           ; *
            FCB     %00100000
            FCB     %10101000
            FCB     %01110000
            FCB     %10101000
            FCB     %00100000
            FCB     %00000000
            ;
            FCB     %11111000           ; 7
            FCB     %00001000
            FCB     %00010000
            FCB     %00100000
            FCB     %01000000
            FCB     %01000000
            FCB     %01000000

            ORG     $FFFE               ; Reset Vector
            FDB     MAIN
            END






